#include <bits/stdc++.h>

using namespace std;

struct Eq {
    int u, v;
    int x;
    // musí platit d[u] >= d[v] + x
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<Eq> eqs;
    vector<long long> dep(n, 0);
    for(int i = 0; i < m; ++i) {
        int u, v, x;
        cin >> u >> v >> x;
        --u; --v;
        eqs.push_back({u, v, x});
    }
    for(int i = 0; i < n+10; ++i) {
        for(auto[u, v, x] : eqs) {
            dep[u] = max(dep[u], dep[v] + x);
        }
    }
    for(auto[u, v, x] : eqs) {
        if(dep[u] < dep[v] + x) {
            cout << "neexistuje" << '\n';
            return;
        }
    }
    for(int i = 0; i < n; ++i) {
        cout << dep[i] << ' ';
    }
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << setprecision(20);

    solve();
}

